<template>
    <div id="calendarexpview_layoutcalendarexpbar" class="app-calendar-exp-bar">
            <div class='calendar-exp-bar-header'>
                <div class="calendar-exp-bar-title">
                    <icon type='ios-home-outline'/>{{ $t('app.calendarExpBar.title') }}
                </div>
            </div>
        <div class="exp-bar-action-container">
            <div class='search-container'>
                <i-input
                    v-model="searchText"
                    :search="true"
                    :placeholder="placeholder"
                    @on-search="onSearch">
                </i-input>
            </div>
            <div class='toolbar-container'>
    <tooltip :transfer="true" :max-width="600">
            <i-button v-show="calendarexpview_layoutcalendarexpbar_toolbarModels.deuiaction3.visabled" :disabled="calendarexpview_layoutcalendarexpbar_toolbarModels.deuiaction3.disabled" class='' v-button-loading:i-button @click="calendarexpbar_toolbar_click({ tag: 'deuiaction3' }, $event)">
                <i class='fa fa-edit'></i>
                <span class='caption'>{{$t('entities.ibizorder.calendarexpview_layoutcalendarexpbar_toolbar_toolbar.deuiaction3.caption')}}</span>
            </i-button>
        <div slot='content'>{{$t('entities.ibizorder.calendarexpview_layoutcalendarexpbar_toolbar_toolbar.deuiaction3.tip')}}</div>
    </tooltip>
</div>
        </div>
        <div class='calendar-exp-bar-content'>
            <view_calendarexpbar_calendar 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context"
    :pViewCtx="viewCtx"
    :showBusyIndicator="true"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="calendarexpbar_calendar"  
    ref='calendarexpbar_calendar' 
    @selectionchange="calendarexpbar_calendar_selectionchange($event)"  
    @load="calendarexpbar_calendar_load($event)"  
    @closeview="closeView($event)">
</view_calendarexpbar_calendar>
        </div>
    </div>
</template>
// 基于 @CONTROL/日历导航/CONTROL-BASE.vue.ftl 生成

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZOrderEntityService from '@/service/ibizorder/ibizorder-service';
import CalendarExpView_layoutcalendarexpbarService from './calendar-exp-view-layoutcalendarexpbar-calendarexpbar-service';
import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';


@Component({
    components: {
      
    }
})
export default class CalendarExpView_layoutcalendarexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数(父级)
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public pViewCtx!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public viewCtx: any = {};

    /**
     * 监听视图操作参数变化
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Watch('pViewCtx', { immediate: true })
    public onViewCtxChange(newVal: any, oldVal: any) {
        Object.assign(this.viewCtx, newVal, { xData: this, ctrl: this });
    }

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public getControlType(): string {
        return 'CALENDAREXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {CalendarExpView_layoutcalendarexpbarService}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public service: CalendarExpView_layoutcalendarexpbarService = new CalendarExpView_layoutcalendarexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public appEntityService: IBIZOrderEntityService = new IBIZOrderEntityService({ $store: this.$store });

    /**
     * calendarexpbar_calendar 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calendarexpbar_calendar_selectionchange($event: any, $event2?: any) {
        this.calendarexpbar_selectionchange($event, 'calendarexpbar_calendar', $event2);
    }

    /**
     * calendarexpbar_calendar 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calendarexpbar_calendar_load($event: any, $event2?: any) {
        this.calendarexpbar_load($event, 'calendarexpbar_calendar', $event2);
    }

    /**
     * calendarexpbar_toolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calendarexpbar_toolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction3')) {
            this.calendarexpbar_toolbar_deuiaction3_click(null, 'calendarexpbar_toolbar', $event2);
        }
    }
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public calendarexpbar_toolbar_deuiaction3_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this.$refs.calendarexpbar_calendar;
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = [...xData.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Edit(datas, contextJO,paramJO,  $event, xData,this,"IBIZOrder");
    }

    /**
     * 编辑
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZOrderCalendarExpView_layoutBase
     */
    public Edit(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        if (args.length === 0) {
            return;
        }
        const _this: any = this;
        if (_this.opendata && _this.opendata instanceof Function) {
            const data: any = { };
            if (args.length > 0) {
                Object.assign(data, { ibizorder: args[0].ibizorder })
            }
            _this.opendata([{ ...data }], args, params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'opendata 视图处理逻辑不存在，请添加!' });
        }
    }

    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  CalendarExpView_layoutcalendarexpbarBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        Object.assign(actionData, args);
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }





    /**
     * 视图唯一标识
     *
     * @type {boolean}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public isSingleSelect:boolean = true;

    /**
     * 可搜索字段名称
     * 
     * 
     * @type {(string)}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public placeholder = "订单名称";

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public searchText: string = "";


    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public navViewName: any = {
        book: "ibizbookedit-view",
        item1: "ibizorder-detail-sgrid-view9"
    };

    /**
     * 导航参数
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public navParam: any = {
        book: {
            navigateContext:{CTXPARAM2:"%ibizbookname%",CTXPARAM1:"xxx2"},
            navigateParams:{param2:"%ibizbookname%",param1:"param3"}
        },
        item1: {
            navigateContext:null,
            navigateParams:null
        }
    };

    /**
     * 导航过滤项
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public navFilter: any = {
        book: "",
        item1: ""
    };

    /**
     * 导航关系
     *
     * @type {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public navPSDer: any = {
        book: "",
        item1: "n_ibizorderid_eq"
    };

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


        /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZOrderCalendarExpView_layout
     */
    public calendarexpview_layoutcalendarexpbar_toolbarModels: any = {
        deuiaction3: { name: 'deuiaction3', actiontarget: 'NONE', caption: '编辑', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Edit', target: 'SINGLEKEY' } },

    };


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public created() {
        this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'calendarexpbar_calendar', action: action, data: data });
            });
        }  
    }
    
    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public afterMounted() { }
 
    /**
     * vue 生命周期
     *
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
    * 刷新
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.calendarexpbar_calendar) {
            refs.calendarexpbar_calendar.refresh();
        }
    }

    /**
     * calendarexpbar的选中数据事件
     * 
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calendarexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        let tempContext:any = {};
        let tempViewParam:any = {};
        if (args.length === 0) {
            this.calcToolbarItemState(true);
            return ;
        }
        const arg:any = args[0];
        if(this.context){
            Object.assign(tempContext,JSON.parse(JSON.stringify(this.context)));
        }
        switch (arg.itemType) {
            case "book":
                Object.assign(tempContext,{ ibizbook : arg.ibizbook});
                Object.assign(tempContext,{srfparentdename:'IBIZBOOK',srfparentkey:arg['ibizbook']});
                if(this.navFilter && this.navFilter['book'] && !Object.is(this.navFilter['book'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['book']]:arg['ibizbook']});
                }
                if(this.navPSDer && this.navFilter['book'] && !Object.is(this.navPSDer['book'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['book']]:arg['ibizbook']});
                }
                if(this.navParam && this.navParam['book'] && this.navParam['book'].navigateContext && Object.keys(this.navParam['book'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['book'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['book'] && this.navParam['book'].navigateParams && Object.keys(this.navParam['book'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['book'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
            case "item1":
                Object.assign(tempContext,{ ibizorder : arg.ibizorder});
                Object.assign(tempContext,{srfparentdename:'IBIZOrder',srfparentkey:arg['ibizorder']});
                if(this.navFilter && this.navFilter['item1'] && !Object.is(this.navFilter['item1'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['item1']]:arg['ibizorder']});
                }
                if(this.navPSDer && this.navFilter['item1'] && !Object.is(this.navPSDer['item1'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['item1']]:arg['ibizorder']});
                }
                if(this.navParam && this.navParam['item1'] && this.navParam['item1'].navigateContext && Object.keys(this.navParam['item1'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['item1'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['item1'] && this.navParam['item1'].navigateParams && Object.keys(this.navParam['item1'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['item1'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
        }
        const navItem: any = {
            navView: this.navViewName[arg.itemType],
            data: args,
            srfnavdata: {
                context: tempContext,
                viewparams: tempViewParam
            }
        }
        this.handleCtrlEvents('onselectionchange', { data: args }).then((res: boolean) => {
            if (!res) {
                this.calcToolbarItemState(true);
                return;
            }
            this.calcToolbarItemState(false);
            this.$emit('selectionchange', navItem);
        })
    }

    /**
     * calendarexpbar的load完成事件
     * 
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calendarexpbar_load(args:any, tag?: string, $event2?: any){
        this.calcToolbarItemState(true);
        this.$emit('load',args);
    }

    /**
     * 设置导航区工具栏禁用状态
     *
     * @param {boolean} state
     * @return {*} 
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calcToolbarItemState(state: boolean) {
        let _this: any = this;
        const models:any = _this.calendarexpview_layoutcalendarexpbar_toolbarModels;
        if (models) {
            for (const key in models) {
                if (!models.hasOwnProperty(key)) {
                    return;
                }
                const _item = models[key];
                if (_item.uiaction && (Object.is(_item.uiaction.target, 'SINGLEKEY') || Object.is(_item.uiaction.target, 'MULTIKEY'))) {
                    _item.disabled = state;
                }
                _item.visabled = true;
                if (_item.noprivdisplaymode && _item.noprivdisplaymode === 6) {
                    _item.visabled = false;
                }
            }
            this.calcNavigationToolbarState();
        }
    }

    /**
     * 计算导航工具栏权限状态
     * 
     * @memberof CalendarExpView_layoutcalendarexpbarBase
     */
    public calcNavigationToolbarState(){
        let _this: any = this;
        // 界面行为
        if(_this.calendarexpview_layoutcalendarexpbar_toolbarModels){
            const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
            ViewTool.calcActionItemAuthState({},_this.calendarexpview_layoutcalendarexpbar_toolbarModels,curUIService);
        }
    }

    /**
    * 执行搜索
    *
    * @memberof CalendarExpView_layoutcalendarexpbarBase
    */
    public onSearch($event:any) {
        let calendar:any = this.$refs.calendarexpbar_calendar;
        calendar.searchEvents({ query: this.searchText });
    }

}
</script>

<style lang='less'>
@import './calendar-exp-view-layoutcalendarexpbar-calendarexpbar.less';
</style>